package it.openutils.spring.rmibernate.server.aspects;

import it.openutils.spring.rmibernate.shared.LazyReference;

import java.lang.reflect.Method;

import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;


/**
 * Aspect on lazy fields to intercept writeReplace
 * @author mmolaschi
 * @version $Id: LazyReferenceAspect.java 485 2007-10-26 11:06:52Z fcarone $
 */
public class LazyReferenceAspect implements MethodInterceptor
{

    private LazyReference lazyReference;

    public LazyReference getLazyReference()
    {
        return lazyReference;
    }

    public void setLazyReference(LazyReference lazyReference)
    {
        this.lazyReference = lazyReference;
    }

    /**
     * {@inheritDoc}
     */
    public Object intercept(Object obj, Method method, Object[] args, MethodProxy proxy) throws Throwable
    {
        return lazyReference;
    }

}
